=== Testing/CMakeLists.txt ===
#---------------------------------------------------------------------
project(elxTesting)

# Set some directories
set(TestDataDir ${elastix_SOURCE_DIR}/Testing/Data)
set(TestBaselineDir ${elastix_SOURCE_DIR}/Testing/Baselines)
set(TestOutputDir ${elastix_BINARY_DIR}/Testing)

set(SITE_BASELINE_DIR "" CACHE PATH "path to site-specific baseline data")
if(SITE_BASELINE_DIR)
  if(EXISTS ${SITE_BASELINE_DIR})
    set(TestSiteBaselineDir ${SITE_BASELINE_DIR})
    message(STATUS "Site-specific baseline directory: " ${TestSiteBaselineDir})
  else()
    message(FATAL_ERROR "Invalid site-specific baseline directory specified: " ${TestSiteBaselineDir})
  endif()
endif()

#---------------------------------------------------------------------
# configure the baseline files
set(ELASTIX_DATA_DIR ${TestDataDir})
file(GLOB files ${TestBaselineDir}/*.in)
if(TestSiteBaselineDir)
  file(GLOB sitefiles ${TestSiteBaselineDir}/*.in)
endif()
foreach(tpfile ${files} ${sitefiles})
  # Get file name without directory
  get_filename_component(tpfileout ${tpfile} NAME)
  # Strip extension .in
  string(REGEX REPLACE "\\.[^.]*$" "" tpfileout ${tpfileout})
  # Replace the initial transform directory with the correct one
  # The resulting file can be found in the binary directory / Testing
  configure_file(${tpfile} ${elastix_BINARY_DIR}/Testing/${tpfileout} @ONLY)
endforeach()

#---------------------------------------------------------------------
# Python is used by some tests
find_program(python_executable python)
if(NOT python_executable)
  message(WARNING "WARNING: python not found! Some test results can not be evaluated.")
endif()

#---------------------------------------------------------------------
# Add macro to decide if mevisdicomtiff should be tested
if(ELASTIX_USE_MEVISDICOMTIFF)
  add_definitions(-D_ELASTIX_USE_MEVISDICOMTIFF)
endif()
set(mevisdcmtifflib mevisdcmtiff)

#---------------------------------------------------------------------
# Optionally run timing tests
# - tests that are wholly devoted to timing can be added conditionally using cmake symbol ELASTIX_TEST_TIMING
# - tests that have mixed correctness and timing testing can use the C Preprocessor symbol _ELASTIX_TEST_TIMING to
#   conditionally enable the timing testing parts
mark_as_advanced(ELASTIX_TEST_TIMING)
option(ELASTIX_TEST_TIMING "Enable timing tests?  This option enables timing tests among the regular test suite." OFF)
if(ELASTIX_TEST_TIMING)
  add_definitions(-D_ELASTIX_TEST_TIMING)
endif()

#---------------------------------------------------------------------
# Core macro for elx_add_opencl_test() and elx_add_test()
macro(elx_add_test_core executable_name source_name test_name group)
  if(NOT TARGET ${executable_name})

    # Create the test executable.
    add_executable(${executable_name} ${source_name}
      itkCommandLineArgumentParser.cxx # some test use the CommandLineArgumentParser
    )

    # Link against other libraries.
    target_link_libraries(${executable_name}
      param               # some test use the CommandLineArgumentParser
      ${mevisdcmtifflib}  # is empty if not selected in CMake
      ${ITK_LIBRARIES}
    )

    if(ELASTIX_USE_OPENCL)
      include_directories(${CMAKE_CURRENT_SOURCE_DIR})
      target_link_libraries(${executable_name} elxOpenCL)
    endif()

    # Group in IDE's like Visual Studio
    set_property(TARGET ${executable_name} PROPERTY FOLDER "tests/${group}")
  endif()

  # Add the test.
  add_test(NAME ${test_name}
    COMMAND ${EXECUTABLE_OUTPUT_PATH}/${executable_name} ${ARGN})

  # GPU test should be run in serial, to avoid memory issues.
  string(COMPARE EQUAL ${group} "OpenCL" isEqual)
  if(${isEqual})
    set_tests_properties(${test_name} PROPERTIES RUN_SERIAL true)
  endif()
endmacro()

#---------------------------------------------------------------------
# Macro that simplifies the addition of elastix OpenCL tests
#
# Usage:
# elx_add_opencl_test(<name_of_test>)
#
# We assume here that the name of the source which includes the main is:
#   "itk"name_of_test".cxx".
#

macro(elx_add_opencl_test name number group kernels)
  # Define some helper variables.
  set(ELXTEST_EXECUTABLE_NAME itk${name})
  set(ELXTEST_SOURCE_NAME itk${name}.cxx itkTestHelper.h itkTestOutputWindow.cxx itkTestOutputWindow.h)
  set(ELXTEST_TEST_NAME ${name}${number})

  # Count number of kernels provided
  set(all_kernels ${kernels})
  list(LENGTH all_kernels ELXTEST_OPENCL_NUM_KERNELS)
  if(${ELXTEST_OPENCL_NUM_KERNELS} GREATER 0)

    # Kernels source variables
    set(ELXTEST_OPEN_CL_KERNELS)
    set(ELXTEST_OPEN_CL_KERNELS_SRC)

    # If single kernel
    if(${ELXTEST_OPENCL_NUM_KERNELS} EQUAL 1)
      # Define OpenCL kernels
      file(GLOB open_cl_kernel_path ${kernels})
      list(APPEND ELXTEST_OPEN_CL_KERNELS ${open_cl_kernel_path})

      source_group("Kernels" FILES ${ELXTEST_OPEN_CL_KERNELS})
      write_opencl_kernels("${ELXTEST_OPEN_CL_KERNELS}" ELXTEST_OPEN_CL_KERNELS_SRC "OpenCLTest generated kernels" OFF ${name})
    # Else if multiple kernels kernel
    elseif(${ELXTEST_OPENCL_NUM_KERNELS} GREATER 1)
      # Define OpenCL kernels
      foreach(elem ${kernels})
        file(GLOB open_cl_kernel_path ${elem})
        list(APPEND ELXTEST_OPEN_CL_KERNELS ${open_cl_kernel_path})
      endforeach()

      source_group("Kernels" FILES ${ELXTEST_OPEN_CL_KERNELS})
      write_opencl_kernels("${ELXTEST_OPEN_CL_KERNELS}" ELXTEST_OPEN_CL_KERNELS_SRC "OpenCLTest generated kernels" ON ${name})
    endif()

    # Append to ELXTEST_SOURCE_NAME
    list(APPEND ELXTEST_SOURCE_NAME ${ELXTEST_OPEN_CL_KERNELS} ${ELXTEST_OPEN_CL_KERNELS_SRC} itk${name}.h)
  endif()

  # Call core macro
  elx_add_test_core(${ELXTEST_EXECUTABLE_NAME} "${ELXTEST_SOURCE_NAME}" ${ELXTEST_TEST_NAME} ${group} ${ARGN})
endmacro()

#---------------------------------------------------------------------
# Macro that simplifies the addition of elastix tests
#
# Usage:
# elx_add_test(<name_of_test>)
#
# We assume here that the name of the source which includes the main is:
#   "itk"name_of_test".cxx".
#

macro(elx_add_test name number group)
  # Define some helper variables.
  set(ELXTEST_EXECUTABLE_NAME itk${name})
  set(ELXTEST_SOURCE_NAME itk${name}.cxx)
  set(ELXTEST_TEST_NAME ${name}${number})

  # Call core macro
  elx_add_test_core(${ELXTEST_EXECUTABLE_NAME} "${ELXTEST_SOURCE_NAME}" ${ELXTEST_TEST_NAME} ${group} ${ARGN})
endmacro()

#---------------------------------------------------------------------
# Macro that simplifies the addition of transformix tests
#
# Usage:
# trx_add_test(<name_of_test> <transformix_commandline_arguments>)
#
# The macro runs transformix with the provided commandline arguments.
#

macro(trx_add_test name)
  # Create output directory
  set(testname transformix_run_${name})
  set(output_dir ${TestOutputDir}/${testname})
  file(MAKE_DIRECTORY ${output_dir})

  # Define some helper variables.
  set(TRXTEST_EXECUTABLE_NAME transformix)
  set(TRXTEST_TEST_NAME ${name})

  # Group in IDE's like Visual Studio
  set_property(TARGET ${ELXTEST_EXECUTABLE_NAME} PROPERTY FOLDER "tests")

  # Add the test.
  add_test(NAME ${name} COMMAND ${EXECUTABLE_OUTPUT_PATH}/transformix ${ARGN} -out ${output_dir})
  set_tests_properties(${name} PROPERTIES TIMEOUT 10000)
endmacro()

#---------------------------------------------------------------------
# Macro's that simplifies the addition of tests that run elastix
#
# Usage:
# elx_add_run_test(<name_of_test>
#                   IMAGE <name_of_baseline> | METRICVALUE "string"
#                     | CHECKSUM "string"
#                   <elastix_commandline_arguments>)
#

# Get the baseline checksum values file
#
# Ideally, a registration returns exactly the same result, regardless of
# platform, OS and compiler. We observed however, that this is not the case.
# Therefore, for some tests we accept differences between systems, and only
# test for consistency over time for the same system.
#
# To this end we have defined baseline checksum values for several systems.
# The code below checks what the current system is and finds the corresponding
# baseline file. We currently do this by means of the CTEST_SITE and CTEST_BUILD_NAME.
# Different sites can give different results, so we only test the checksum for
# the sites that are known to us, and those are the sites that submit to the
# nightly dashboard. Note that this means that these checksum comparison test
# only work if run via the dashboard scripts.
#
set(knownChecksumSystem false)
set(specializedTransformParameterSystem false)
if(SITE STREQUAL "LKEB.PCMarius"
    AND BUILDNAME STREQUAL "Win10-64bit-VS2015")
  set(checksumBaselineFile ${TestBaselineDir}/checksums_LKEB.PCMarius_Win10-64bit-VS2015.txt)
  set(knownChecksumSystem true)
  set(specializedTransformParameterSystem true)
elseif(SITE STREQUAL "LKEB-ELDB91"
    AND BUILDNAME STREQUAL "Linux-64bit-gcc5.4.0-Release")
  set(checksumBaselineFile ${TestBaselineDir}/checksums_LKEB.ELDB91_Linux-64bit-gcc5.txt)
  set(knownChecksumSystem true)
  set(specializedTransformParameterSystem true)
elseif(SITE STREQUAL "LKEB.MacMini"
    AND BUILDNAME STREQUAL "MacOSX-64bit-gcc4.2.1")
  set(checksumBaselineFile ${TestBaselineDir}/checksums_LKEB.MacMini_MacOSX-64bit-gcc4.txt)
  set(knownChecksumSystem true)
  set(specializedTransformParameterSystem true)
elseif(SITE STREQUAL "BIGR.PCStefan"
    AND BUILDNAME STREQUAL "WinXP-32bit-VS2008")
  set(checksumBaselineFile ${TestBaselineDir}/checksums_BIGR.PCStefan_WinXP-32bit-VS2008.txt)
  set(knownChecksumSystem true)
  set(specializedTransformParameterSystem true)
elseif(SITE STREQUAL "BIGR.cluster"
    AND BUILDNAME STREQUAL "Linux-64bit-gcc4.4.6")
  set(checksumBaselineFile ${TestBaselineDir}/checksums_BIGR.cluster_Linux-64bit-gcc4.txt)
  set(knownChecksumSystem true)
  set(specializedTransformParameterSystem true)
endif()

if(EXISTS ${TestSiteBaselineDir}/checksums.txt)
  set(checksumBaselineFile ${TestSiteBaselineDir}/checksums.txt)
  set(knownChecksumSystem true)
endif()

if(knownChecksumSystem)
  message(STATUS "Checksum baseline file: " ${checksumBaselineFile})
endif()

# Python script used for comparing elastix output with baseline results
set(pythonfinalmetric ${elastix_SOURCE_DIR}/Testing/elx_compare_finalmetricvalue.py)
set(pythonchecksum   ${elastix_SOURCE_DIR}/Testing/elx_compare_checksum.py)
set(pythonoverlap    ${elastix_SOURCE_DIR}/Testing/elx_compare_overlap.py)
set(pythonlandmarks  ${elastix_SOURCE_DIR}/Testing/elx_compare_landmarks.py)

# Helper macro
macro(list_count listvar value count)
  set(tmplist)
  foreach(tmpvalue ${listvar})
    if(${tmpvalue} STREQUAL ${value})
      list(APPEND tmplist .)
    endif()
  endforeach()
  list(LENGTH tmplist tmpcount)
  set(${count} ${tmpcount})
endmacro()

# Main elastix_run add_test macro
macro(elx_add_run_test testbasename howtocompare)
  if(ELASTIX_BUILD_EXECUTABLE)
    # Create output directory
    set(testname elastix_run_${testbasename})
    set(output_dir ${TestOutputDir}/${testname})
    file(MAKE_DIRECTORY ${output_dir})

    # ${ARGN} may be the elastix command line arguments, but also
    # an optional baseline value followed by those arguments.
    set(baseline ${ARGV2})
    set(elastixargs ${ARGN})
    string(SUBSTRING ${baseline} 0 1 firstelement)
    string(COMPARE EQUAL ${firstelement} "-" firstelementisdash)
    if(NOT ${firstelementisdash})
      list(REMOVE_AT elastixargs 0)
    endif()

    # Number of -p's to deduce result.?.mhd
    list_count("${ARGN}" "-p" countp)
    math(EXPR countp "${countp} - 1")

    # Run elastix, but only in release mode
    # Set maximum test length to 10 minutes
    add_test(NAME ${testname}_OUTPUT
      CONFIGURATIONS Release
      COMMAND ${EXECUTABLE_OUTPUT_PATH}/elastix
      ${elastixargs} -out ${output_dir})
    set_tests_properties(${testname}_OUTPUT
      PROPERTIES TIMEOUT 600)

    # To compare against a baseline TransformParameters file
