=== Common/ParameterFileParser/CMakeLists.txt ===
# Sources of non-templated classes.
set(param_SRCS
  itkParameterFileParser.h
  itkParameterFileParser.cxx
  itkParameterMapInterface.h
  itkParameterMapInterface.cxx
)

source_group("Parser" FILES ${param_SRCS})

add_library(param STATIC ${param_SRCS})
if(NOT ELASTIX_NO_INSTALL_DEVELOPMENT)
  install(TARGETS param
    ARCHIVE DESTINATION ${ELASTIX_ARCHIVE_DIR}
    LIBRARY DESTINATION ${ELASTIX_LIBRARY_DIR}
    RUNTIME DESTINATION ${ELASTIX_RUNTIME_DIR}
    COMPONENT Development)
endif()

target_link_libraries(param ${ITK_LIBRARIES})

# Group in IDE's like Visual Studio
set_property(TARGET param PROPERTY FOLDER "libraries")
