=== Testing/PythonTests/requirements.txt ===
itk
SimpleITK
numpy
