=== Components/FixedImagePyramids/FixedGenericPyramid/CMakeLists.txt ===

ADD_ELXCOMPONENT( FixedGenericPyramid
 elxFixedGenericPyramid.h
 elxFixedGenericPyramid.hxx
 elxFixedGenericPyramid.cxx)
