=== debian/changelog ===
elastix (5.2.0-2ubuntu1) plucky; urgency=medium

  * d/rules: disable LTO to fix FTBFS with undefined reference.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 21 Feb 2025 13:00:28 +0000

elastix (5.2.0-2build1) plucky; urgency=medium

  * No-change rebuild for libinsighttoolkit5.4.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 18 Feb 2025 16:48:13 +0000

elastix (5.2.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Steve M. Robbins <smr@debian.org>  Tue, 11 Feb 2025 20:13:12 -0600

elastix (5.2.0-1) experimental; urgency=medium

  * [2fabde9] New upstream version 5.2.0
  * [78f5e90] Bump ITK dependency to v 5.4.
  * [87b0963] Refresh patches.
  * [a6bd404] update manpages

 -- Steve M. Robbins <smr@debian.org>  Thu, 30 Jan 2025 23:23:59 -0600
